package com.cloudcross.ssp.web.advertiser.main.ad.target;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.cloudcross.ssp.base.web.SimpleController;
import com.cloudcross.ssp.common.utils.Pager;
import com.cloudcross.ssp.model.Account;
import com.cloudcross.ssp.model.Location;
import com.cloudcross.ssp.model.Operator;
import com.cloudcross.ssp.model.Place;
import com.cloudcross.ssp.model.PlaceClassInformation;
import com.cloudcross.ssp.model.PlaceOperator;
import com.cloudcross.ssp.model.Wifi;
import com.cloudcross.ssp.model.Zone;
import com.cloudcross.ssp.model.pojo.CampaignPojo;
import com.cloudcross.ssp.service.ICampaignService;
import com.cloudcross.ssp.service.ILocationService;
import com.cloudcross.ssp.service.IOperatorService;
import com.cloudcross.ssp.service.IPlaceClassInformationService;
import com.cloudcross.ssp.service.IPlaceOperatorService;
import com.cloudcross.ssp.service.IPlaceService;
import com.cloudcross.ssp.service.IWifiService;
import com.cloudcross.ssp.service.IZoneService;

@Controller
@RequestMapping("/advertiser/main/ad/target/ad-group-alloperator")
public class AdGroupAlloperatorController extends SimpleController{
	
	@Autowired
	private ICampaignService campaignService;
	@Autowired
	private ILocationService locationService;
	@Autowired
	private IOperatorService operatorService;
	@Autowired
	private IPlaceOperatorService placeOperatorService;
	@Autowired
	private IPlaceClassInformationService placeClassInformationService;
	@Autowired
	private IPlaceService placeService;
	@Autowired
	private IWifiService wifiService;
	@Autowired
	private IZoneService zoneService;
	
	@RequestMapping("create")
	public String create(Model model, @RequestParam Long campaignId) {
		Account account = getLoginUser();
		Long operatorId = account.getOperatorId();
		
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("operatorId", operatorId);
		List<Integer> positionList = new ArrayList<Integer>();
		positionList.add(1);
		condition.put("positionList", positionList);
		//List<Zone> zoneList = zoneService.queryZoneByCondition(condition);//获取广告位
		CampaignPojo campaign = campaignService.findCampaignById(campaignId);
		//找到所有的场景，并且显示出来
		//List<PlaceClassInformation> placeList = placeClassInformationService.findAll();
		
		
		model.addAttribute("campaignId", campaignId);
		model.addAttribute("advertiserId", campaign.getAdvertiserId());	
		model.addAttribute("orderId", campaign.getOrderId());
		model.addAttribute("agentId", campaign.getAgentId());
		model.addAttribute("budget", campaign.getTotalBudget());
		//model.addAttribute("placeList",placeList);
		//model.addAttribute("zoneList",zoneList);
		return page("create");
	}
	
	/**
	 * 选择广告位
	 * @param model
	 * @param operatorId 运营商ID {id1，id2，id3，...}
	 * @param position 位置{position1,position2,position3,...}
	 * @return
	 */
	@RequestMapping("chooseZone")
	@ResponseBody
	public List<Zone> queryZoneByCondition(Model model,String operatorId,String position){
		Map<String,Object> condition = new HashMap<String,Object>();
		//处理operatorID
		if(operatorId != null && !"".equals(operatorId)){
			condition.put("operatorId", operatorId);
		}
		//处理position
		if(position != null && !"".equals(position)){
			condition.put("position", position);
		}
		List<Zone> zoneList = this.zoneService.queryZone(condition);
		return zoneList;
	}
	/**
	 * 到选择媒体弹窗
	 * 创建人：周俊
	 * 创建时间：2015.12.11 17：00
	 * @return
	 */
	@RequestMapping("chooseOperator")
	public String chooseOperatorWindow(Model model,@RequestParam(defaultValue = "1") int page){
		Integer count = this.operatorService.queryAllOperatorCount();
		Pager pager = new Pager();
		pager.setPage(page);
		pager.setTotalRow(count);
		
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("pager", pager);
		List<Operator> list = this.operatorService.queryAllOperator(condition);
		model.addAttribute("operatorList", list);
		model.addAttribute("pager", pager);
		return page("operatorWindow");
	}
	
	
	/**
	 * 选择媒体场景
	 * 创建人：周俊
	 * 创建时间：2015.12.11 17：52
	 * 每个运营商场景显示：{场景ID，运营商名+运营商场景，数聚小场景}即：{id,getOperatorShowName(),placeId}其中placeId要传到后台
	 * @return
	 */
	@RequestMapping("chooseOperatorPlace")
	public String chooseOperatorPlaceWindow(Model model,@RequestParam(defaultValue = "1") int page){
		Integer count = this.placeOperatorService.queryOperatorPlaceCount();
		Pager pager = new Pager();
		pager.setPage(page);
		pager.setTotalRow(count);
		
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("pager", pager);
		List<PlaceOperator> list = this.placeOperatorService.queryOperatorPlace(condition);
		model.addAttribute("pager", pager);
		model.addAttribute("list", list);
		return page("operatorPlaceWindow");
	}
	
	/**
	 * 选择大场景
	 * 创建人：周俊
	 * 创建时间：2015-12-14 11.30
	 * @param model
	 * @param page
	 * @return
	 */
	@RequestMapping("choosePlaceClass")
	public String choosePlaceClassWindow(Model model,@RequestParam(defaultValue = "1") int page){
		Integer count = this.placeClassInformationService.queryPlaceClassCount();
		Pager pager = new Pager();
		pager.setPage(page);
		pager.setTotalRow(count);
		
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("pager", pager);
		List<PlaceClassInformation> list = this.placeClassInformationService.queryPlaceClass(condition);
		model.addAttribute("pager", pager);
		model.addAttribute("list", list);
		return page("placeClassWindow");
	}
	
	/**
	 * 选择小场景
	 * @param model
	 * @param page
	 * @return
	 */
	@RequestMapping("choosePlace")
	public String choosePlaceWindow(Model model,@RequestParam(defaultValue = "1") int page){
		Integer count = this.placeService.queryPlaceCount();
		Pager pager = new Pager();
		pager.setPage(page);
		pager.setTotalRow(count);
		
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("pager", pager);
		List<Place> list = this.placeService.queryPlace(condition);
		model.addAttribute("pager", pager);
		model.addAttribute("list", list);
		return page("placeWindow");
	}
	
	/**
	 * 选择终端
	 * @param model
	 * @param page
	 * @param cnCity
	 * @param cn
	 * @return
	 */
	@RequestMapping("chooseWifi")
	public String chooseWifiWindow(Model model,@RequestParam(defaultValue = "1") int page,String cnCity,String cn){
		Map<String,Object> condition = new HashMap<String,Object>();
		if( null != cnCity && !"".equals(cnCity)){
			condition.put("cnCity", cnCity);
		}
		if( null != cn && !"".equals(cn)){
			condition.put("cn", cn);
		}
		
		Integer count = this.wifiService.queryWifiCount(condition);
		Pager pager = new Pager();
		pager.setPage(page);
		pager.setTotalRow(count);
		if(cn == null || "".equals(cn)){
			cn = "省";
		}
		if(cnCity == null || "".equals(cnCity)){
			cnCity = "市";
		}
		condition.put("pager", pager);
		List<Wifi> list = this.wifiService.queryWifi(condition);
		model.addAttribute("pager", pager);
		model.addAttribute("cnCity", cnCity);
		model.addAttribute("cn", cn);
		model.addAttribute("list", list);
		return page("wifiWindow");
	}
	
	/**
	 * 查找所有的省
	 * @return
	 */
	@RequestMapping("/cn")
	public @ResponseBody
	Map<String, List<String>> findAllProvince() {
		List<String> provinceList = locationService.findAllProvince();
		Map<String, List<String>> map = new HashMap<String, List<String>>();
		map.put("province", provinceList);
		return map;
	}
	
	/**
	 * 查找该省下的所有城市
	 * @param province
	 * @return
	 */
	@RequestMapping("/city")
	public @ResponseBody
	Map<String, List<String>> findCityByProvince(@RequestParam String province) {
		//这里如果传递过来的参数是空值或者空字符串则返回一个空值
		if(null == province || "".equals(province)) {
			System.out.println("传递的参数出错");
			return null;
		}
		
		try {
			province = new String(province.getBytes("ISO-8859-1"),"UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		List<String> cityList = locationService.findCityByProvince(province);
		Map<String, List<String>> map = new HashMap<String, List<String>>();
		map.put("city", cityList);
		return map;
	}
	
	/**
	 * 保存方法
	 * @param request
	 * @param model
	 * @return
	 */
	@RequestMapping("/save")
	public String save(HttpServletRequest request, Model model){
		return OK;
	}
	
}
